<?php 

defined('APPLICATION') or die();

function smarty_function_kryptronicstartup ($params, &$smarty) {

// +--
// | Include the configuration file.
// +--

$kryptronic_config = array();
$kryptronic_path   = PATH_THEMES . DS . 'kryptronic';

@include($kryptronic_path . DS . 'CONFIGURE.php');

// +--
// | Define variables for caching the output of the 
// | Kryptronic remote skin.
// +--

$cachefile          = $kryptronic_path . DS . 'CACHE.txt';
$kryptronic_get     = 1;
$kryptronic_content = '';
$eol                = "\r\n";

global $kryptronic_skin;

// +--
// | If our time to live (TTL) is greater than zero, we
// | delete the cache file if it's TTL is expired, and
// | set a get variable to load a Kryptronic remote skin.
// |
// | If the cache file exists, and is still valid pull
// | it's content.
// +--

if (!(empty($kryptronic_config['cachettl']))) {

     if (@file_exists($cachefile)) {

          $current_time = @time();
          $filemod_time = @filemtime($cachefile);

          if ($current_time > ($filemod_time + $kryptronic_config['cachettl'])) {

               @unlink($cachefile);

          } else {

               $kryptronic_get     = 0;
               $kryptronic_content = @file_get_contents($cachefile);

          } // End of if statement.

     } // End of if statement.

} // End of if statement.

// +--
// | If we need to load a Kryptronic remote skin, do so using
// | cURL and save it's content to a variable.
// +--

if (!(empty($kryptronic_get))) {

     $krypturl  = $kryptronic_config['connect_url'];
     $kryptdata = array();

     $kryptcrl = curl_init();

     curl_setopt($kryptcrl, CURLOPT_URL, $krypturl);
     curl_setopt($kryptcrl, CURLOPT_RETURNTRANSFER, 1);
     curl_setopt($kryptcrl, CURLOPT_CONNECTTIMEOUT, 5);
     curl_setopt($kryptcrl, CURLOPT_POST, 1);
     curl_setopt($kryptcrl, CURLOPT_POSTFIELDS, $kryptdata);
     curl_setopt($kryptcrl, CURLOPT_SSL_VERIFYPEER, 0);
     curl_setopt($kryptcrl, CURLOPT_SSL_VERIFYHOST, 0);
     curl_setopt($kryptcrl, CURLOPT_DNS_USE_GLOBAL_CACHE, 0);

     $kryptronic_content = curl_exec($kryptcrl);

     curl_close($kryptcrl);

} // End of if statement.

// +--
// | If we have content, parse it for special tags which will be
// | used to mark insertion points for Vanilla code as well as 
// | Ajax requests back to the Kryptronic skin source.
// +--

if ((!(empty($kryptronic_content))) && (preg_match('/remoteskinexporter/',$kryptronic_content))) {

     // +--
     // | Write out a new cache file, if we are supposed to and 
     // | we just pulled content from a Kryptronic remote skin.
     // +--

     if ((!(empty($kryptronic_get))) && (!(empty($kryptronic_config['cachettl'])))) {

          if (file_exists($cachefile)) {@unlink($cachefile);}

          $fh = @fopen($cachefile, 'wb');

          if ($fh) {

               @flock($fh, LOCK_EX);
               @fwrite($fh, $kryptronic_content);
               @flock($fh, LOCK_UN);
               @fclose($fh);
               @clearstatcache();
               @chmod($cachefile, intval('777', 8));

          } // End of if statement.

     } // End of if statement.

     // +--
     // | Parse special tags...
     // +--

     $tags = array('cssjs'   => '<remoteskinexporter:cssjs />',
                   'body'    => '<body class="kwrap">',
                   'content' => '<remoteskinexporter:content />');

     foreach ($tags as $tid => $tag) {$tags[$tid] = preg_quote($tag,'/');}

     $kryptstr = preg_replace('/^(.*?)' . $tags['cssjs'] . '(.*?)$/s','\\1',$kryptronic_content);
     $kryptronic_skin['cssjs'] = $kryptstr;

     $kryptstr = preg_replace('/^(.*?)' . $tags['cssjs'] . '(.*?)' . $tags['body'] . '(.*?)$/s','\\2',$kryptronic_content);
     $kryptronic_skin['prebody'] = $kryptstr;

     $kryptstr = preg_replace('/^(.*?)' . $tags['body'] . '(.*?)' . $tags['content'] . '(.*?)$/s','\\2',$kryptronic_content);
     $kryptronic_skin['precontent'] = $kryptstr;

     $kryptstr = preg_replace('/^(.*?)' . $tags['content'] . '(.*?)$/s','\\2',$kryptronic_content);
     $kryptronic_skin['postcontent'] = $kryptstr;

     foreach ($kryptronic_skin as $ksid => $kscontent) {

          $kryptronic_skin[$ksid] = preg_replace('/\<remoteskinexporter\:.*?\/>/s','',$kscontent);

     } // End of foreach statement.

} // End of if statement.

} // End of function.

?>